Index: .bzrignore
===================================================================
--- .bzrignore	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ .bzrignore	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -9,4 +9,7 @@
 _link.ld
 ./*.iso
+_link-dlexe.ld
+_link-loader.ld
+_link-shlib.ld
 
 ./tools/__pycache__/
@@ -50,4 +53,5 @@
 ./uspace/app/klog/klog
 ./uspace/app/lsusb/lsusb
+./uspace/app/mkbd/mkbd
 ./uspace/app/mkfat/mkfat
 ./uspace/app/netstart/netstart
Index: boot/Makefile
===================================================================
--- boot/Makefile	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ boot/Makefile	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -55,4 +55,7 @@
 		cp "$$file" "$(DIST_PATH)/srv/" ; \
 	done
+	for file in $(RD_LIBS) ; do \
+		cp "$$file" "$(DIST_PATH)/lib/" ; \
+	done
 	for file in $(RD_APPS) ; do \
 		cp "$$file" "$(DIST_PATH)/app/" ; \
@@ -83,4 +86,5 @@
 	rm -f $(USPACE_PATH)/dist/srv/*
 	rm -rf $(USPACE_PATH)/dist/drv/*
+	rm -f $(USPACE_PATH)/dist/lib/*
 	rm -f $(USPACE_PATH)/dist/app/*
 	rm -f $(USPACE_PATH)/dist/cfg/net/*
Index: boot/Makefile.build
===================================================================
--- boot/Makefile.build	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ boot/Makefile.build	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -40,5 +40,5 @@
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
 	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
-	-Werror-implicit-function-declaration -Wwrite-strings \
+	-std=gnu99 -Werror-implicit-function-declaration -Wwrite-strings \
 	-pipe
 
@@ -111,5 +111,5 @@
 
 $(RAW): $(OBJECTS) $(COMPONENT_OBJECTS) $(LINK)
-	$(LD) -N $(LFLAGS) -T $(LINK) -M -Map $(MAP) -o $@ $(COMPONENT_OBJECTS) $(OBJECTS)
+	$(LD) -n $(LFLAGS) -T $(LINK) -M -Map $(MAP) -o $@ $(COMPONENT_OBJECTS) $(OBJECTS)
 
 $(LINK): $(LINK).comp $(DEPEND)
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ boot/Makefile.common	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -118,4 +118,14 @@
 RD_DRV_CFG = 
 
+RD_LIBS =
+
+ifeq ($(CONFIG_BUILD_SHARED_LIBS), y)
+	RD_LIBS += \
+		$(USPACE_PATH)/lib/c/libc.so0 \
+		$(USPACE_PATH)/lib/softint/libsofti.so0
+	RD_APPS += \
+		$(USPACE_PATH)/app/dltest/dltest
+endif
+
 RD_APPS_ESSENTIAL = \
 	$(USPACE_PATH)/app/bdsh/bdsh \
@@ -124,4 +134,7 @@
 
 RD_APPS_NON_ESSENTIAL = \
+	$(USPACE_PATH)/app/dltest/dltest \
+	$(USPACE_PATH)/app/dltest2/dltest2 \
+	$(USPACE_PATH)/app/dload/dload \
 	$(USPACE_PATH)/app/edit/edit \
 	$(USPACE_PATH)/app/kill/kill \
Index: boot/arch/ia64/_link.ld.in
===================================================================
--- boot/arch/ia64/_link.ld.in	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ boot/arch/ia64/_link.ld.in	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -11,6 +11,6 @@
 		*(.rodata);
 		*(.rodata.*);
-		*(.data);               /* initialized data */
-		_got = . ;
+		*(.data .data.*);       /* initialized data */
+		__gp = . ;
 		*(.got .got.*);
 		*(.bss);                /* uninitialized static variables */
@@ -20,6 +20,5 @@
 
 	/DISCARD/ : {
-		*(.comment);
-		*(.note*);
+		*(.*);
 	}
 }
Index: boot/arch/ia64/src/boot.S
===================================================================
--- boot/arch/ia64/src/boot.S	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ boot/arch/ia64/src/boot.S	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -34,5 +34,5 @@
 .global start
 start:
-	movl gp = LOADER_ADDRESS
+	movl gp = __gp
 
 	#
Index: contrib/tools/font/bdf2c.pl
===================================================================
--- contrib/tools/font/bdf2c.pl	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
+++ contrib/tools/font/bdf2c.pl	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -0,0 +1,164 @@
+#!/usr/bin/perl -w
+
+#
+# Copyright (c) 2000 Dmitry Bolkhovityanov
+# Copyright (c) 2009 Martin Decky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+use strict;
+
+my $skip;
+
+my $width;
+my $height;
+my $offset_x;
+my $offset_y;
+
+my $gwidth;
+my $gheight;
+my $goffset_x;
+my $goffset_y;
+
+my $index;
+my @glyphs;
+my @chars;
+
+open(BDF, "u_vga16.bdf") or die("Unable to open source font\n");
+
+READHEADER: while (<BDF>) {
+	/^FONTBOUNDINGBOX\s/ and do {
+		($skip, $width, $height, $offset_x, $offset_y) = (split);
+		
+		die("Font width is not 8px\n") if ($width != 8);
+		die("Font height is not 16px\n") if ($height != 16);
+	};
+	/^CHARS\s/ && last READHEADER;
+}
+
+READCHARS: while (<BDF>) {
+	/^ENCODING\s+([0-9]+)\s*$/ && do {
+		$index = $1;
+	};
+	/^BBX\s/ && do {
+		($skip, $gwidth, $gheight, $goffset_x, $goffset_y) = (split);
+	};
+	/^BITMAP/ && do {
+		my @glyph = ();
+		my $y;
+		
+		# Add empty lines at top
+		my $empties = $height + $offset_y - $goffset_y - $gheight;
+		
+		for ($y = 0; $y < $empties; $y++) {
+			$glyph[$y] = 0;
+		}
+		
+		# Scan the hex bitmap
+		for ($y = $empties; $y < $empties + $gheight; $y++) {
+			$_ = <BDF>;
+			$glyph[$y] = hex(substr($_, 0, 2)) >> $goffset_x;
+		}
+		
+		# Add empty lines at bottom
+		my $fill = $height - $gheight - $empties;
+		for ($y = $empties + $gheight; $y < $empties + $gheight + $fill; $y++) {
+			$glyph[$y] = 0;
+		}
+		
+		if ($index != 0) {
+			$glyphs[$index] = (\@glyph);
+			push(@chars, $index);
+		}
+	};
+	/^ENDFONT/ && last READCHARS;
+}
+
+close(BDF);
+
+@chars = sort { $a <=> $b } (@chars);
+
+print "#define FONT_GLYPHS     " . (@chars + 1). "\n";
+print "#define FONT_SCANLINES  " . $height . "\n";
+
+print "\n";
+print "uint16_t fb_font_glyph(const wchar_t ch)\n";
+print "{\n";
+print "\tif (ch == 0x0000)\n";
+print "\t\treturn 0;\n\n";
+
+my $pos = 0;
+my $start = -1;
+my $start_pos = 0;
+my $prev = 0;
+for $index (@chars) {
+	if ($prev + 1 < $index) {
+		if ($start != -1) {
+			if ($start == $prev) {
+				printf "\tif (ch == 0x%.4x)\n", $start;
+				print "\t\treturn " . $start_pos . ";\n";
+			} else {
+				printf "\tif ((ch >= 0x%.4x) && (ch <= 0x%.4x))\n", $start, $prev;
+				print "\t\treturn (ch - " . ($start - $start_pos) . ");\n";
+			}
+			
+			print "\t\n";
+		}
+		
+		$start = $index;
+		$start_pos = $pos;
+	}
+	
+	$pos++;
+	$prev = $index;
+}
+
+print "\treturn " . @chars . ";\n";
+print "}\n";
+
+print "\n";
+print "uint8_t fb_font[FONT_GLYPHS][FONT_SCANLINES] = {";
+
+for $index (@chars) {
+	print "\n\t{";
+	
+	my $y;
+	for ($y = 0; $y < $height; $y++) {
+		print ", " if ($y > 0);
+		printf "0x%.2x", $glyphs[$index]->[$y];
+	}
+	
+	print "},";
+}
+
+print "\n\t\n\t/* Special glyph for unknown character */\n\t{";
+my $y;
+for ($y = 0; $y < $height; $y++) {
+	print ", " if ($y > 0);
+	printf "0x%.2x", $glyphs[63]->[$y];
+}
+
+print "}\n};\n";
Index: contrib/tools/serengeti_silo.sh
===================================================================
--- contrib/tools/serengeti_silo.sh	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
+++ contrib/tools/serengeti_silo.sh	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -0,0 +1,74 @@
+#!/bin/bash
+
+# Download SILO and patch it so that it can be used to create a bootable CD
+# for the Serengeti machine
+#  by Pavel Rimsky <rimskyp@seznam.cz>
+#  portions by Martin Decky <martin@decky.cz>
+#
+#  GPL'ed, copyleft
+#
+
+# stuff to be downloaded
+SILO_DOWNLOAD_FILE='silo-loaders-1.4.11.tar.gz'
+SILO_DOWNLOAD_URL='http://silo.auxio.org/pub/silo/old/'$SILO_DOWNLOAD_FILE
+
+# check whether the last command failed, if so, write an error message and exit
+check_error() {
+    if [ "$1" -ne "0" ]; then
+        echo
+        echo "Script failed: $2"
+        exit
+    fi
+}
+
+# temporary files are to be stored in /tmp
+# the resulting file in the current directory
+WD=`pwd`
+cd /tmp
+
+# download SILO from its official website
+echo ">>> Downloading SILO"
+wget $SILO_DOWNLOAD_URL
+check_error $? "Error downloading SILO."
+
+# unpack the downloaded file
+echo ">>> Unpacking tarball"
+tar xvzf $SILO_DOWNLOAD_FILE
+check_error $? "Error unpacking tarball."
+
+# CD to the unpacked directory
+echo ">>> Changing to the unpacked SILO directory"
+cd boot
+check_error $? "Changing directory failed."
+
+# patch it - remove bytes 512 to 512 + 32 (counted from 0), which belong to
+# the ELF header which is not recognized by the Serengeti firmware
+echo ">>> Patching SILO"
+(((xxd -p -l 512 isofs.b) && (xxd -p -s 544 isofs.b)) | xxd -r -p) \
+	 > isofs.b.patched
+check_error $? "Patching SILO failed"
+mv isofs.b.patched isofs.b
+
+# get rid of files which are not needed for creating the bootable CD
+echo ">>> Purging SILO directory"
+for file in `ls`; do
+	if [ \( -f $file \) -a \( $file != "isofs.b" \) -a \( $file != "second.b" \) ];
+		then
+		rm -fr $file;
+	fi
+done
+check_error $? "Purging SILO directory failed"
+
+# create the gzipped tarball with patched SILO
+echo ">>> Creating tarball with patched SILO"
+tar cvzf silo.patched.tar.gz *.b
+check_error $? "Creating tarball with patched SILO failed"
+
+# and move it to the directory where the user expects it to be
+echo ">>> Moving the tarball with patched SILO to the current directory"
+mv silo.patched.tar.gz $WD
+check_error $? "Moving the tarball with patched SILO failed"
+
+# move back to the working directory from /tmp
+cd $WD
+
Index: kernel/Makefile
===================================================================
--- kernel/Makefile	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/Makefile	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -94,5 +94,5 @@
 	-fexec-charset=UTF-8 -fwide-exec-charset=UTF-32$(ENDIANESS) \
 	-finput-charset=UTF-8 -ffreestanding -fno-builtin -nostdlib -nostdinc \
-	-Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
+	-std=gnu99 -Wall -Wextra -Wno-unused-parameter -Wmissing-prototypes \
 	-Werror-implicit-function-declaration -Wwrite-strings \
 	-pipe
@@ -134,5 +134,5 @@
 #
 AFLAGS =
-LFLAGS = -N -T $(LINK) -M
+LFLAGS = -n -T $(LINK) -M
 
 #
@@ -228,4 +228,5 @@
 	generic/src/syscall/syscall.c \
 	generic/src/syscall/copy.c \
+	generic/src/mm/reserve.c \
 	generic/src/mm/buddy.c \
 	generic/src/mm/frame.c \
Index: kernel/arch/abs32le/include/types.h
===================================================================
--- kernel/arch/abs32le/include/types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/abs32le/include/types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -40,4 +40,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/amd64/include/types.h
===================================================================
--- kernel/arch/amd64/include/types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/amd64/include/types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,4 +37,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 
 typedef uint64_t uintptr_t;
Index: kernel/arch/amd64/src/interrupt.c
===================================================================
--- kernel/arch/amd64/src/interrupt.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/amd64/src/interrupt.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -66,28 +66,27 @@
 void istate_decode(istate_t *istate)
 {
-	printf("cs =%#0" PRIx64 "\trip=%p\t"
-	    "rfl=%#0" PRIx64 "\terr=%#0" PRIx64 "\n",
-	    istate->cs, (void *) istate->rip,
-	    istate->rflags, istate->error_word);
+	printf("cs =%0#18" PRIx64 "\trip=%0#18" PRIx64 "\t"
+	    "rfl=%0#18" PRIx64 "\terr=%0#18" PRIx64 "\n",
+	    istate->cs, istate->rip, istate->rflags, istate->error_word);
 	
 	if (istate_from_uspace(istate))
-		printf("ss =%#0" PRIx64 "\n", istate->ss);
-	
-	printf("rax=%#0" PRIx64 "\trbx=%#0" PRIx64 "\t"
-	    "rcx=%#0" PRIx64 "\trdx=%#0" PRIx64 "\n",
+		printf("ss =%0#18" PRIx64 "\n", istate->ss);
+	
+	printf("rax=%0#18" PRIx64 "\trbx=%0#18" PRIx64 "\t"
+	    "rcx=%0#18" PRIx64 "\trdx=%0#18" PRIx64 "\n",
 	    istate->rax, istate->rbx, istate->rcx, istate->rdx);
 	
-	printf("rsi=%p\trdi=%p\trbp=%p\trsp=%p\n",
-	    (void *) istate->rsi, (void *) istate->rdi,
-	    (void *) istate->rbp,
-	    istate_from_uspace(istate) ? ((void *) istate->rsp) :
-	    &istate->rsp);
-	
-	printf("r8 =%#0" PRIx64 "\tr9 =%#0" PRIx64 "\t"
-	    "r10=%#0" PRIx64 "\tr11=%#0" PRIx64 "\n",
+	printf("rsi=%0#18" PRIx64 "\trdi=%0#18" PRIx64 "\t"
+	    "rbp=%0#18" PRIx64 "\trsp=%0#18" PRIx64 "\n",
+	    istate->rsi, istate->rdi, istate->rbp,
+	    istate_from_uspace(istate) ? istate->rsp :
+	    (uintptr_t) &istate->rsp);
+	
+	printf("r8 =%0#18" PRIx64 "\tr9 =%0#18" PRIx64 "\t"
+	    "r10=%0#18" PRIx64 "\tr11=%0#18" PRIx64 "\n",
 	    istate->r8, istate->r9, istate->r10, istate->r11);
 	
-	printf("r12=%#0" PRIx64 "\tr13=%#0" PRIx64 "\t"
-	    "r14=%#0" PRIx64 "\tr15=%#0" PRIx64 "\n",
+	printf("r12=%0#18" PRIx64 "\tr13=%0#18" PRIx64 "\t"
+	    "r14=%0#18" PRIx64 "\tr15=%0#18" PRIx64 "\n",
 	    istate->r12, istate->r13, istate->r14, istate->r15);
 }
Index: kernel/arch/arm32/include/types.h
===================================================================
--- kernel/arch/arm32/include/types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/arm32/include/types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -44,4 +44,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/arm32/src/exception.c
===================================================================
--- kernel/arch/arm32/src/exception.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/arm32/src/exception.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -174,17 +174,16 @@
 void istate_decode(istate_t *istate)
 {
-	printf("r0 =%#0" PRIx32 "\tr1 =%#0" PRIx32 "\t"
-	    "r2 =%#0" PRIx32 "\tr3 =%#0" PRIx32 "\n",
+	printf("r0 =%0#10" PRIx32 "\tr1 =%0#10" PRIx32 "\t"
+	    "r2 =%0#10" PRIx32 "\tr3 =%0#10" PRIx32 "\n",
 	    istate->r0, istate->r1, istate->r2, istate->r3);
-	printf("r4 =%#" PRIx32 "\tr5 =%#0" PRIx32 "\t"
-	    "r6 =%#0" PRIx32 "\tr7 =%#0" PRIx32 "\n",
+	printf("r4 =%0#10" PRIx32 "\tr5 =%0#10" PRIx32 "\t"
+	    "r6 =%0#10" PRIx32 "\tr7 =%0#10" PRIx32 "\n",
 	    istate->r4, istate->r5, istate->r6, istate->r7);
-	printf("r8 =%#0" PRIx32 "\tr9 =%#0" PRIx32 "\t"
-	    "r10=%#0" PRIx32 "\tfp =%p\n",
-	    istate->r8, istate->r9, istate->r10,
-	    (void *) istate->fp);
-	printf("r12=%#0" PRIx32 "\tsp =%p\tlr =%p\tspsr=%p\n",
-	    istate->r12, (void *) istate->sp,
-	    (void *) istate->lr, (void *) istate->spsr);
+	printf("r8 =%0#10" PRIx32 "\tr9 =%0#10" PRIx32 "\t"
+	    "r10=%0#10" PRIx32 "\tfp =%0#10" PRIx32 "\n",
+	    istate->r8, istate->r9, istate->r10, istate->fp);
+	printf("r12=%0#10" PRIx32 "\tsp =%0#10" PRIx32 "\t"
+	    "lr =%0#10" PRIx32 "\tspsr=%0#10" PRIx32 "\n",
+	    istate->r12, istate->sp, istate->lr, istate->spsr);
 }
 
Index: kernel/arch/ia32/Makefile.inc
===================================================================
--- kernel/arch/ia32/Makefile.inc	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ia32/Makefile.inc	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -35,5 +35,5 @@
 ENDIANESS = LE
 
-CMN1 = -m32
+CMN1 = -m32 -fno-omit-frame-pointer
 GCC_CFLAGS += $(CMN1)
 ICC_CFLAGS += $(CMN1)
Index: kernel/arch/ia32/include/barrier.h
===================================================================
--- kernel/arch/ia32/include/barrier.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ia32/include/barrier.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -54,4 +54,5 @@
 NO_TRACE static inline void cpuid_serialization(void)
 {
+#ifndef __IN_SHARED_LIBC__
 	asm volatile (
 		"xorl %%eax, %%eax\n"
@@ -59,4 +60,14 @@
 		::: "eax", "ebx", "ecx", "edx", "memory"
 	);
+#else
+	/* Must not clobber PIC register ebx */
+	asm volatile (
+		"movl %%ebx, %%esi\n"
+		"xorl %%eax, %%eax\n"
+		"cpuid\n"
+		"movl %%esi, %%ebx\n"
+		::: "eax", "ecx", "edx", "esi", "memory"
+	);
+#endif
 }
 
Index: kernel/arch/ia32/include/types.h
===================================================================
--- kernel/arch/ia32/include/types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ia32/include/types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,4 +37,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/ia32/src/interrupt.c
===================================================================
--- kernel/arch/ia32/src/interrupt.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ia32/src/interrupt.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -66,25 +66,24 @@
 void istate_decode(istate_t *istate)
 {
-	printf("cs =%#0" PRIx32 "\teip=%p\t"
-	    "efl=%#0" PRIx32 "\terr=%#0" PRIx32 "\n",
-	    istate->cs, (void *) istate->eip,
-	    istate->eflags, istate->error_word);
-	
-	printf("ds =%#0" PRIx32 "\tes =%#0" PRIx32 "\t"
-	    "fs =%#0" PRIx32 "\tgs =%#0" PRIx32 "\n",
+	printf("cs =%0#10" PRIx32 "\teip=%0#10" PRIx32 "\t"
+	    "efl=%0#10" PRIx32 "\terr=%0#10" PRIx32 "\n",
+	    istate->cs, istate->eip, istate->eflags, istate->error_word);
+	
+	printf("ds =%0#10" PRIx32 "\tes =%0#10" PRIx32 "\t"
+	    "fs =%0#10" PRIx32 "\tgs =%0#10" PRIx32 "\n",
 	    istate->ds, istate->es, istate->fs, istate->gs);
 	
 	if (istate_from_uspace(istate))
-		printf("ss =%#0" PRIx32 "\n", istate->ss);
-	
-	printf("eax=%#0" PRIx32 "\tebx=%#0" PRIx32 "\t"
-	    "ecx=%#0" PRIx32 "\tedx=%#0" PRIx32 "\n",
+		printf("ss =%0#10" PRIx32 "\n", istate->ss);
+	
+	printf("eax=%0#10" PRIx32 "\tebx=%0#10" PRIx32 "\t"
+	    "ecx=%0#10" PRIx32 "\tedx=%0#10" PRIx32 "\n",
 	    istate->eax, istate->ebx, istate->ecx, istate->edx);
 	
-	printf("esi=%p\tedi=%p\tebp=%p\tesp=%p\n",
-	    (void *) istate->esi, (void *) istate->edi,
-	    (void *) istate->ebp,
-	    istate_from_uspace(istate) ? ((void *) istate->esp) :
-	    &istate->esp);
+	printf("esi=%0#10" PRIx32 "\tedi=%0#10" PRIx32 "\t"
+	    "ebp=%0#10" PRIx32 "\tesp=%0#10" PRIx32 "\n",
+	    istate->esi, istate->edi, istate->ebp,
+	    istate_from_uspace(istate) ? istate->esp :
+	    (uintptr_t) &istate->esp);
 }
 
Index: kernel/arch/ia64/_link.ld.in
===================================================================
--- kernel/arch/ia64/_link.ld.in	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ia64/_link.ld.in	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -30,4 +30,5 @@
 		hardcoded_kdata_size = .;
 		QUAD(kdata_end - kdata_start);
+		__gp = .;
 		*(.got .got.*)
 		*(.sdata)
Index: kernel/arch/ia64/include/types.h
===================================================================
--- kernel/arch/ia64/include/types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ia64/include/types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,4 +37,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 
 typedef uint64_t uintptr_t;
Index: kernel/arch/ia64/src/ivt.S
===================================================================
--- kernel/arch/ia64/src/ivt.S	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ia64/src/ivt.S	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -391,5 +391,5 @@
 
     /* 10. call handler */
-    	movl r1 = kernel_image_start
+    	movl r1 = __gp
     
     	mov b1 = loc2
Index: kernel/arch/ia64/src/start.S
===================================================================
--- kernel/arch/ia64/src/start.S	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ia64/src/start.S	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -174,7 +174,7 @@
 	
 	# Initialize gp (Global Pointer) register
-	movl gp = kernel_image_start
+	movl gp = __gp
 	
-	#	
+	#
 	# Initialize bootinfo on BSP.
 	#
Index: kernel/arch/mips32/include/types.h
===================================================================
--- kernel/arch/mips32/include/types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/mips32/include/types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,4 +37,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/mips32/src/exception.c
===================================================================
--- kernel/arch/mips32/src/exception.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/mips32/src/exception.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -74,8 +74,7 @@
 void istate_decode(istate_t *istate)
 {
-	printf("epc=%p\tsta=%#010" PRIx32 "\t"
+	printf("epc=%#010" PRIx32 "\tsta=%#010" PRIx32 "\t"
 	    "lo =%#010" PRIx32 "\thi =%#010" PRIx32 "\n",
-	    (void *) istate->epc, istate->status,
-	    istate->lo, istate->hi);
+	    istate->epc, istate->status, istate->lo, istate->hi);
 	
 	printf("a0 =%#010" PRIx32 "\ta1 =%#010" PRIx32 "\t"
@@ -107,7 +106,7 @@
 	    istate->s8, istate->at, istate->kt0, istate->kt1);
 	
-	printf("sp =%p\tra =%p\tgp =%p\n",
-	    (void *) istate->sp, (void *) istate->ra,
-	    (void *) istate->gp);
+	printf("sp =%#010" PRIx32 "\tra =%#010" PRIx32 "\t"
+	    "gp =%#010" PRIx32 "\n",
+	    istate->sp, istate->ra, istate->gp);
 }
 
Index: kernel/arch/mips32/src/mm/frame.c
===================================================================
--- kernel/arch/mips32/src/mm/frame.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/mips32/src/mm/frame.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -88,5 +88,5 @@
 	/* gxemul devices */
 	if (overlaps(frame << ZERO_PAGE_WIDTH, ZERO_PAGE_SIZE,
-	    0x10000000, MB2SIZE(256)))
+	    0x10000000, MiB2SIZE(256)))
 		return false;
 #endif
Index: kernel/arch/ppc32/include/types.h
===================================================================
--- kernel/arch/ppc32/include/types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ppc32/include/types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,4 +37,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/ppc32/src/interrupt.c
===================================================================
--- kernel/arch/ppc32/src/interrupt.c	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/ppc32/src/interrupt.c	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -54,44 +54,44 @@
 void istate_decode(istate_t *istate)
 {
-	printf("r0 =%#0" PRIx32 "\tr1 =%p\tr2 =%#0" PRIx32 "\n",
-	    istate->r0, (void *) istate->sp, istate->r2);
+	printf("r0 =%0#10" PRIx32 "\tr1 =%0#10" PRIx32 "\t"
+	    "r2 =%0#10" PRIx32 "\n", istate->r0, istate->sp, istate->r2);
 	
-	printf("r3 =%#0" PRIx32 "\tr4 =%#0" PRIx32 "\tr5 =%#0" PRIx32 "\n",
-	    istate->r3, istate->r4, istate->r5);
+	printf("r3 =%0#10" PRIx32 "\tr4 =%0#10" PRIx32 "\t"
+	    "r5 =%0#10" PRIx32 "\n", istate->r3, istate->r4, istate->r5);
 	
-	printf("r6 =%#0" PRIx32 "\tr7 =%#0" PRIx32 "\tr8 =%#0" PRIx32 "\n",
-	    istate->r6, istate->r7, istate->r8);
+	printf("r6 =%0#10" PRIx32 "\tr7 =%0#10" PRIx32 "\t"
+	    "r8 =%0#10" PRIx32 "\n", istate->r6, istate->r7, istate->r8);
 	
-	printf("r9 =%#0" PRIx32 "\tr10=%#0" PRIx32 "\tr11=%#0" PRIx32 "\n",
-	    istate->r9, istate->r10, istate->r11);
+	printf("r9 =%0#10" PRIx32 "\tr10=%0#10" PRIx32 "\t"
+	    "r11=%0#10" PRIx32 "\n", istate->r9, istate->r10, istate->r11);
 	
-	printf("r12=%#0" PRIx32 "\tr13=%#0" PRIx32 "\tr14=%#0" PRIx32 "\n",
-	    istate->r12, istate->r13, istate->r14);
+	printf("r12=%0#10" PRIx32 "\tr13=%0#10" PRIx32 "\t"
+	    "r14=%0#10" PRIx32 "\n", istate->r12, istate->r13, istate->r14);
 	
-	printf("r15=%#0" PRIx32 "\tr16=%#0" PRIx32 "\tr17=%#0" PRIx32 "\n",
-	    istate->r15, istate->r16, istate->r17);
+	printf("r15=%0#10" PRIx32 "\tr16=%0#10" PRIx32 "\t"
+	    "r17=%0#10" PRIx32 "\n", istate->r15, istate->r16, istate->r17);
 	
-	printf("r18=%#0" PRIx32 "\tr19=%#0" PRIx32 "\tr20=%#0" PRIx32 "\n",
-	    istate->r18, istate->r19, istate->r20);
+	printf("r18=%0#10" PRIx32 "\tr19=%0#10" PRIx32 "\t"
+	    "r20=%0#10" PRIx32 "\n", istate->r18, istate->r19, istate->r20);
 	
-	printf("r21=%#0" PRIx32 "\tr22=%#0" PRIx32 "\tr23=%#0" PRIx32 "\n",
-	    istate->r21, istate->r22, istate->r23);
+	printf("r21=%0#10" PRIx32 "\tr22=%0#10" PRIx32 "\t"
+	    "r23=%0#10" PRIx32 "\n", istate->r21, istate->r22, istate->r23);
 	
-	printf("r24=%#0" PRIx32 "\tr25=%#0" PRIx32 "\tr26=%#0" PRIx32 "\n",
-	    istate->r24, istate->r25, istate->r26);
+	printf("r24=%0#10" PRIx32 "\tr25=%0#10" PRIx32 "\t"
+	    "r26=%0#10" PRIx32 "\n", istate->r24, istate->r25, istate->r26);
 	
-	printf("r27=%#0" PRIx32 "\tr28=%#0" PRIx32 "\tr29=%#0" PRIx32 "\n",
-	    istate->r27, istate->r28, istate->r29);
+	printf("r27=%0#10" PRIx32 "\tr28=%0#10" PRIx32 "\t"
+	    "r29=%0#10" PRIx32 "\n", istate->r27, istate->r28, istate->r29);
 	
-	printf("r30=%#0" PRIx32 "\tr31=%#0" PRIx32 "\n",
+	printf("r30=%0#10" PRIx32 "\tr31=%0#10" PRIx32 "\n",
 	    istate->r30, istate->r31);
 	
-	printf("cr =%#0" PRIx32 "\tpc =%p\tlr =%p\n",
-	    istate->cr, (void *) istate->pc, (void *) istate->lr);
+	printf("cr =%0#10" PRIx32 "\tpc =%0#10" PRIx32 "\t"
+	    "lr =%0#10" PRIx32 "\n", istate->cr, istate->pc, istate->lr);
 	
-	printf("ctr=%#0" PRIx32 "\txer=%#0" PRIx32 "\tdar=%#0" PRIx32 "\n",
-	    istate->ctr, istate->xer, istate->dar);
+	printf("ctr=%0#10" PRIx32 "\txer=%0#10" PRIx32 "\t"
+	    "dar=%0#10" PRIx32 "\n", istate->ctr, istate->xer, istate->dar);
 	
-	printf("srr1=%p\n", (void *) istate->srr1);
+	printf("srr1=%0#10" PRIx32 "\n", istate->srr1);
 }
 
Index: kernel/arch/sparc64/include/cpu.h
===================================================================
--- kernel/arch/sparc64/include/cpu.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/sparc64/include/cpu.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -59,9 +59,4 @@
 #include <arch/asm.h>
 
-#ifdef CONFIG_SMP
-#include <arch/mm/cache.h>
-#endif
-
-
 #if defined (SUN4U)
 #include <arch/sun4u/cpu.h>
Index: kernel/arch/sparc64/include/sun4u/cpu.h
===================================================================
--- kernel/arch/sparc64/include/sun4u/cpu.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/sparc64/include/sun4u/cpu.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -60,8 +60,4 @@
 #include <trace.h>
 
-#ifdef CONFIG_SMP
-#include <arch/mm/cache.h>
-#endif
-
 typedef struct {
 	uint32_t mid;              /**< Processor ID as read from
Index: kernel/arch/sparc64/include/types.h
===================================================================
--- kernel/arch/sparc64/include/types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/arch/sparc64/include/types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -37,4 +37,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 
 typedef uint64_t uintptr_t;
Index: kernel/generic/include/ipc/event.h
===================================================================
--- kernel/generic/include/ipc/event.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/generic/include/ipc/event.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -51,26 +51,32 @@
 	/** Counter. */
 	size_t counter;
+	/** Masked flag. */
+	bool masked;
+	/** Unmask callback. */
+	void (*unmask_cb)(void);
 } event_t;
 
 extern void event_init(void);
+extern void event_cleanup_answerbox(answerbox_t *);
+extern void event_set_unmask_callback(event_type_t, void (*)(void));
+
+#define event_notify_0(e, m) \
+	event_notify((e), (m), 0, 0, 0, 0, 0)
+#define event_notify_1(e, m, a1) \
+	event_notify((e), (m), (a1), 0, 0, 0, 0)
+#define event_notify_2(e, m, a1, a2) \
+	event_notify((e), (m), (a1), (a2), 0, 0, 0)
+#define event_notify_3(e, m, a1, a2, a3) \
+	event_notify((e), (m), (a1), (a2), (a3), 0, 0)
+#define event_notify_4(e, m, a1, a2, a3, a4) \
+	event_notify((e), (m), (a1), (a2), (a3), (a4), 0)
+#define event_notify_5(e, m, a1, a2, a3, a4, a5) \
+	event_notify((e), (m), (a1), (a2), (a3), (a4), (a5))
+
+extern int event_notify(event_type_t, bool, sysarg_t, sysarg_t, sysarg_t,
+    sysarg_t, sysarg_t);
+
 extern sysarg_t sys_event_subscribe(sysarg_t, sysarg_t);
-extern bool event_is_subscribed(event_type_t);
-extern void event_cleanup_answerbox(answerbox_t *);
-
-#define event_notify_0(e) \
-	event_notify((e), 0, 0, 0, 0, 0)
-#define event_notify_1(e, a1) \
-	event_notify((e), (a1), 0, 0, 0, 0)
-#define event_notify_2(e, a1, a2) \
-	event_notify((e), (a1), (a2), 0, 0, 0)
-#define event_notify_3(e, a1, a2, a3) \
-	event_notify((e), (a1), (a2), (a3), 0, 0)
-#define event_notify_4(e, a1, a2, a3, a4) \
-	event_notify((e), (a1), (a2), (a3), (a4), 0)
-#define event_notify_5(e, a1, a2, a3, a4, a5) \
-	event_notify((e), (a1), (a2), (a3), (a4), (a5))
-
-extern void event_notify(event_type_t, sysarg_t, sysarg_t, sysarg_t,
-    sysarg_t, sysarg_t);
+extern sysarg_t sys_event_unmask(sysarg_t);
 
 #endif
Index: kernel/generic/include/ipc/event_types.h
===================================================================
--- kernel/generic/include/ipc/event_types.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/generic/include/ipc/event_types.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -39,5 +39,5 @@
 	/** New data available in kernel log */
 	EVENT_KLOG = 0,
-	/** Returning from kernel console to userspace */
+	/** Returning from kernel console to uspace */
 	EVENT_KCONSOLE,
 	/** A task/thread has faulted and will be terminated */
Index: kernel/generic/include/macros.h
===================================================================
--- kernel/generic/include/macros.h	(revision df44fa2ce2cd4c6a7125a389be0292b42d1d62b3)
+++ kernel/generic/include/macros.h	(revision d09f37205721ab861f408e36aa5b0e169abffef0)
@@ -95,9 +95,6 @@
 	overlaps(KA2PA((x)), (szx), KA2PA((y)), (szy))
 
-#define SIZE2KB(size)  ((size) >> 10)
-#define SIZE2MB(size)  ((size) >> 20)
-
-#define KB2SIZE(kb)  ((kb) << 10)
-#define MB2SIZE(mb)  ((mb) << 20)
+#define KiB2SIZE(kb)  ((kb) << 10)
+#define MiB2SIZE(mb)  ((mb) << 20)
 
 #define STRING(arg)      STRING_ARG(arg)
